searchNodes=[{"ref":"ZXCVBN.html","title":"ZXCVBN","module":"ZXCVBN","type":"module","doc":"ZXCVBN is an Elixir implemenation of ZXCVBN. The original paper is available here. The usage is simple: iex&gt; ZXCVBN.zxcvbn(&quot;password&quot;) %{ calc_time: 51, crack_times_display: %{ offline_fast_hashing_1e10_per_second: &quot;less than a second&quot;, offline_slow_hashing_1e4_per_second: &quot;less than a second&quot;, online_no_throttling_10_per_second: &quot;less than a second&quot;, online_throttling_100_per_hour: &quot;1 minute&quot; }, crack_times_seconds: %{ offline_fast_hashing_1e10_per_second: 3.0e-10, offline_slow_hashing_1e4_per_second: 0.0003, online_no_throttling_10_per_second: 0.3, online_throttling_100_per_hour: 108.0 }, feedback: %{ suggestions: [&quot;Add another word or two. Uncommon words are better.&quot;, &quot;Predictable substitutions like &#39;@&#39; instead of &#39;a&#39; don&#39;t help very much&quot;], warning: &quot;&quot; }, guesses: 3, guesses_log10: 0.47712125471966244, password: &quot;password&quot;, score: 0, sequence: [ %{ base_guesses: 2, dictionary_name: :passwords, guesses: 2, guesses_log10: 0.3010299956639812, i: 0, j: 7, l33t: false, l33t_variations: 1, matched_word: &quot;password&quot;, pattern: :dictionary, rank: 2, reversed: false, token: &quot;password&quot;, uppercase_variations: 1 } ] } You can also pass of list of user inputs that will act as additional dictionary. This is useful for checking if the password is not same or variant of associated user inputs. iex&gt; ZXCVBN.zxcvbn(&quot;nepal&quot;, [&quot;samar&quot;, &quot;mustang&quot;, &quot;nepal&quot;, &quot;hello@example.com&quot;])"},{"ref":"ZXCVBN.html#zxcvbn/2","title":"ZXCVBN.zxcvbn/2","module":"ZXCVBN","type":"function","doc":""},{"ref":"ZXCVBN.AdjacencyGraphs.html","title":"ZXCVBN.AdjacencyGraphs","module":"ZXCVBN.AdjacencyGraphs","type":"module","doc":"Adjacency graph ceated by this script"},{"ref":"ZXCVBN.AdjacencyGraphs.html#adjacency_graph/0","title":"ZXCVBN.AdjacencyGraphs.adjacency_graph/0","module":"ZXCVBN.AdjacencyGraphs","type":"function","doc":""},{"ref":"ZXCVBN.Feedback.html","title":"ZXCVBN.Feedback","module":"ZXCVBN.Feedback","type":"module","doc":"Feedback module to produce warning and suggestions"},{"ref":"ZXCVBN.Feedback.html#get_dictionary_match_feedback/2","title":"ZXCVBN.Feedback.get_dictionary_match_feedback/2","module":"ZXCVBN.Feedback","type":"function","doc":""},{"ref":"ZXCVBN.Feedback.html#get_feedback/2","title":"ZXCVBN.Feedback.get_feedback/2","module":"ZXCVBN.Feedback","type":"function","doc":""},{"ref":"ZXCVBN.Feedback.html#get_match_feedback/2","title":"ZXCVBN.Feedback.get_match_feedback/2","module":"ZXCVBN.Feedback","type":"function","doc":""},{"ref":"ZXCVBN.FrequencyLists.html","title":"ZXCVBN.FrequencyLists","module":"ZXCVBN.FrequencyLists","type":"module","doc":"Frequency Lists created by this script"},{"ref":"ZXCVBN.FrequencyLists.html#frequency_lists/0","title":"ZXCVBN.FrequencyLists.frequency_lists/0","module":"ZXCVBN.FrequencyLists","type":"function","doc":""},{"ref":"ZXCVBN.Matching.html","title":"ZXCVBN.Matching","module":"ZXCVBN.Matching","type":"module","doc":"Matching module"},{"ref":"ZXCVBN.Matching.html#add_frequency_lists/2","title":"ZXCVBN.Matching.add_frequency_lists/2","module":"ZXCVBN.Matching","type":"function","doc":""},{"ref":"ZXCVBN.Matching.html#build_ranked_dict/1","title":"ZXCVBN.Matching.build_ranked_dict/1","module":"ZXCVBN.Matching","type":"function","doc":""},{"ref":"ZXCVBN.Matching.html#date_match/2","title":"ZXCVBN.Matching.date_match/2","module":"ZXCVBN.Matching","type":"function","doc":"a &quot;date&quot; is recognized as: any 3-tuple that starts or ends with a 2- or 4-digit year, with 2 or 0 separator chars (1.1.91 or 1191), maybe zero-padded (01-01-91 vs 1-1-91), a month between 1 and 12, a day between 1 and 31. note: this isn&#39;t true date parsing in that &quot;feb 31st&quot; is allowed, this doesn&#39;t check for leap years, etc. recipe: start with regex to find maybe-dates, then attempt to map the integers onto month-day-year to filter the maybe-dates into dates. finally, remove matches that are substrings of other matches to reduce noise. note: instead of using a lazy or greedy regex to find many dates over the full string, this uses a ^...$ regex against every substring of the password -- less performant but leads to every possible date match."},{"ref":"ZXCVBN.Matching.html#dedup/1","title":"ZXCVBN.Matching.dedup/1","module":"ZXCVBN.Matching","type":"function","doc":""},{"ref":"ZXCVBN.Matching.html#do_sequence_match/2","title":"ZXCVBN.Matching.do_sequence_match/2","module":"ZXCVBN.Matching","type":"function","doc":""},{"ref":"ZXCVBN.Matching.html#map_ints_to_dmy/1","title":"ZXCVBN.Matching.map_ints_to_dmy/1","module":"ZXCVBN.Matching","type":"function","doc":"given a 3-tuple, discard if: middle int is over 31 (for all dmy formats, years are never allowed in the middle) middle int is zero any int is over the max allowable year any int is over two digits but under the min allowable year 2 ints are over 31, the max allowable day 2 ints are zero all ints are over 12, the max allowable month"},{"ref":"ZXCVBN.Matching.html#omnimatch/2","title":"ZXCVBN.Matching.omnimatch/2","module":"ZXCVBN.Matching","type":"function","doc":"omnimatch -- perform all matches"},{"ref":"ZXCVBN.Matching.html#regex_match/3","title":"ZXCVBN.Matching.regex_match/3","module":"ZXCVBN.Matching","type":"function","doc":""},{"ref":"ZXCVBN.Matching.html#sequence_match/2","title":"ZXCVBN.Matching.sequence_match/2","module":"ZXCVBN.Matching","type":"function","doc":""},{"ref":"ZXCVBN.Matching.html#spatial_match_helper/3","title":"ZXCVBN.Matching.spatial_match_helper/3","module":"ZXCVBN.Matching","type":"function","doc":""},{"ref":"ZXCVBN.Scoring.html","title":"ZXCVBN.Scoring","module":"ZXCVBN.Scoring","type":"module","doc":"Score calculation"},{"ref":"ZXCVBN.Scoring.html#most_guessable_match_sequence/3","title":"ZXCVBN.Scoring.most_guessable_match_sequence/3","module":"ZXCVBN.Scoring","type":"function","doc":"search --- most guessable match sequence ------------------------------------- takes a sequence of overlapping matches, returns the non-overlapping sequence with minimum guesses. the following is a O(l_max * (n + m)) dynamic programming algorithm for a length-n password with m candidate matches. l_max is the maximum optimal sequence length spanning each prefix of the password. In practice it rarely exceeds 5 and the search terminates rapidly. the optimal &quot;minimum guesses&quot; sequence is here defined to be the sequence that minimizes the following function: g = l! * Product(m.guesses for m in sequence) + D^(l - 1) where l is the length of the sequence. the factorial term is the number of ways to order l patterns. the D^(l-1) term is another length penalty, roughly capturing the idea that an attacker will try lower-length sequences first before trying length-l sequences. for example, consider a sequence that is date-repeat-dictionary. an attacker would need to try other date-repeat-dictionary combinations, hence the product term. an attacker would need to try repeat-date-dictionary, dictionary-repeat-date, ..., hence the factorial term. an attacker would also likely try length-1 (dictionary) and length-2 (dictionary-date) sequences before length-3. assuming at minimum D guesses per pattern type, D^(l-1) approximates Sum(D^i for i in [1..l-1]"},{"ref":"ZXCVBN.Scoring.html#nCk/2","title":"ZXCVBN.Scoring.nCk/2","module":"ZXCVBN.Scoring","type":"function","doc":"Reference: http://blog.plover.com/math/choose.html"},{"ref":"ZXCVBN.Scoring.html#re_all_upper/0","title":"ZXCVBN.Scoring.re_all_upper/0","module":"ZXCVBN.Scoring","type":"function","doc":""},{"ref":"ZXCVBN.Scoring.html#re_start_upper/0","title":"ZXCVBN.Scoring.re_start_upper/0","module":"ZXCVBN.Scoring","type":"function","doc":""},{"ref":"ZXCVBN.Scoring.html#reference_year/0","title":"ZXCVBN.Scoring.reference_year/0","module":"ZXCVBN.Scoring","type":"function","doc":""},{"ref":"ZXCVBN.Scoring.html#spatial_guesses/1","title":"ZXCVBN.Scoring.spatial_guesses/1","module":"ZXCVBN.Scoring","type":"function","doc":""},{"ref":"ZXCVBN.TimeEstimates.html","title":"ZXCVBN.TimeEstimates","module":"ZXCVBN.TimeEstimates","type":"module","doc":"Calculate various attacking times"},{"ref":"ZXCVBN.TimeEstimates.html#estimate_attack_times/1","title":"ZXCVBN.TimeEstimates.estimate_attack_times/1","module":"ZXCVBN.TimeEstimates","type":"function","doc":""},{"ref":"ZXCVBN.Utils.html","title":"ZXCVBN.Utils","module":"ZXCVBN.Utils","type":"module","doc":"Helper functions"},{"ref":"ZXCVBN.Utils.html#calc_average_degree/1","title":"ZXCVBN.Utils.calc_average_degree/1","module":"ZXCVBN.Utils","type":"function","doc":""},{"ref":"ZXCVBN.Utils.html#downcase/1","title":"ZXCVBN.Utils.downcase/1","module":"ZXCVBN.Utils","type":"function","doc":""},{"ref":"ZXCVBN.Utils.html#factorial/1","title":"ZXCVBN.Utils.factorial/1","module":"ZXCVBN.Utils","type":"function","doc":""},{"ref":"ZXCVBN.Utils.html#file_to_list/1","title":"ZXCVBN.Utils.file_to_list/1","module":"ZXCVBN.Utils","type":"function","doc":""},{"ref":"ZXCVBN.Utils.html#pow/2","title":"ZXCVBN.Utils.pow/2","module":"ZXCVBN.Utils","type":"function","doc":""},{"ref":"ZXCVBN.Utils.html#slice/2","title":"ZXCVBN.Utils.slice/2","module":"ZXCVBN.Utils","type":"function","doc":""},{"ref":"ZXCVBN.Utils.html#slice/3","title":"ZXCVBN.Utils.slice/3","module":"ZXCVBN.Utils","type":"function","doc":""},{"ref":"ZXCVBN.Utils.html#strlen/1","title":"ZXCVBN.Utils.strlen/1","module":"ZXCVBN.Utils","type":"function","doc":""},{"ref":"ZXCVBN.Utils.html#time/0","title":"ZXCVBN.Utils.time/0","module":"ZXCVBN.Utils","type":"function","doc":""},{"ref":"readme.html","title":"zxcvbn-elixir","module":"readme","type":"extras","doc":"zxcvbn-elixir Elixir implementation of zxcvbn by dropbox"},{"ref":"readme.html#installation","title":"zxcvbn-elixir - Installation","module":"readme","type":"extras","doc":"def deps do [ {:zxcvbn, &quot;~&gt; 0.1.3&quot;} ] end"},{"ref":"readme.html#usage","title":"zxcvbn-elixir - Usage","module":"readme","type":"extras","doc":"import ZXCVBN # default without user inputs zxcvbn(&quot;Some Password&quot;) # with user inputs; useful for adding to dictionary (for eg. submitted form inputs; # think someone using their e-mail address as password for example) zxcvbn(&quot;Password1&quot;, [&quot;user@email.com&quot;, &quot;Nepal&quot;, &quot;Kathmandu&quot;]) Usage Notes Ideally, when you are using ZXCVBN, pass the first 100-200 characters only for reasonable latency."},{"ref":"readme.html#output-description","title":"zxcvbn-elixir - Output Description","module":"readme","type":"extras","doc":"The result of running ZXCVBN.zxcvbn/1 and ZXCVBN.zxcvbn/2 is a map except for when empty string is supplied as password (which returns :error). Below is a sample result and description of each fields. %{ # how long it took zxcvbn to calculate an answer, # in milliseconds. calc_time: 51, # same keys as result.crack_times_seconds, # with friendlier display string values: # &quot;less than a second&quot;, &quot;3 hours&quot;, &quot;centuries&quot;, etc. crack_times_display: %{ offline_fast_hashing_1e10_per_second: &quot;less than a second&quot;, offline_slow_hashing_1e4_per_second: &quot;less than a second&quot;, online_no_throttling_10_per_second: &quot;less than a second&quot;, online_throttling_100_per_hour: &quot;1 minute&quot; }, # dictionary of back-of-the-envelope crack time # estimations, in seconds, based on a few scenarios crack_times_seconds: %{ # offline attack with user-unique salting but a fast hash # function like SHA-1, SHA-256 or MD5. A wide range of # reasonable numbers anywhere from one billion - one trillion # guesses per second, depending on number of cores and machines. # ballparking at 10B/sec. offline_fast_hashing_1e10_per_second: 3.0e-10, # offline attack. assumes multiple attackers, # proper user-unique salting, and a slow hash function # w/ moderate work factor, such as bcrypt, scrypt, PBKDF2. offline_slow_hashing_1e4_per_second: 0.0003, # online attack on a service that doesn&#39;t ratelimit, # or where an attacker has outsmarted ratelimiting. online_no_throttling_10_per_second: 0.3, # online attack on a service that ratelimits password auth attempts online_throttling_100_per_hour: 108.0 }, # verbal feedback to help choose better passwords. set when score &lt;= 2. feedback: %{ # a possibly-empty list of suggestions to help choose a less # guessable password. eg. &#39;Add another word or two&#39; suggestions: [&quot;Add another word or two. Uncommon words are better.&quot;, &quot;Predictable substitutions like &#39;@&#39; instead of &#39;a&#39; don&#39;t help very much&quot;], # explains what&#39;s wrong, eg. &#39;this is a top-10 common password&#39;. # not always set -- sometimes an empty string warning: &quot;&quot; }, # estimated guesses needed to crack password guesses: 3, # order of magnitude of guesses guesses_log10: 0.47712125471966244, # input password password: &quot;password&quot;, # Integer from 0-4 (useful for implementing a strength bar) # 0 too guessable: risky password. (guesses &lt; 10^3) # 1 very guessable: protection from throttled online attacks. (guesses &lt; 10^6) # 2 somewhat guessable: protection from unthrottled online attacks. (guesses &lt; 10^8) # 3 safely unguessable: moderate protection from offline slow-hash scenario. (guesses &lt; 10^10) # 4 very unguessable: strong protection from offline slow-hash scenario. (guesses &gt;= 10^10) score: 0, # the list of patterns that zxcvbn based the # guess calculation on. sequence: [ %{ base_guesses: 2, dictionary_name: :passwords, guesses: 2, guesses_log10: 0.3010299956639812, i: 0, j: 7, l33t: false, l33t_variations: 1, matched_word: &quot;password&quot;, pattern: :dictionary, rank: 2, reversed: false, token: &quot;password&quot;, uppercase_variations: 1 } ] }"},{"ref":"readme.html#benchmark","title":"zxcvbn-elixir - Benchmark","module":"readme","type":"extras","doc":"The basic benchmark result can be seen by running: mix run bench/run.exs That will create html output on benchmarks directory."},{"ref":"readme.html#test","title":"zxcvbn-elixir - Test","module":"readme","type":"extras","doc":"The zxcvbn.js is used to test the correctness with the original implementation. ZXCVBN is a pure Elixir implementation and not a wrapper on top of javascript version. Test Setup npm install mix test"},{"ref":"readme.html#author","title":"zxcvbn-elixir - Author","module":"readme","type":"extras","doc":"Samar Acharya"}]